#pragma once

#include <windows.h>
#include <map>

// Lqqx[X(ʕ)
struct TS_DESCRIPTOR_BASE
{
	BYTE	byTag;		// Lqqʃ^O
	BYTE	byLength;	// Lqq̒
};

// ZkCxgLqq
struct TS_DESCRIPTOR_SHORT_EVENT : public TS_DESCRIPTOR_BASE
{
	char	LanguageCode[3];	// R[h({Ȃjpn)
	char	EventName[81];		// Cxg
	char	Text[161];			// Cxg
};



// LqqǗNX
class CTsDescriptors
{
public:
	CTsDescriptors(bool bOriginalFlg = true)
	{
		m_bOriginalFlg = bOriginalFlg;
		m_Descriptors.clear();
	}
	~CTsDescriptors()
	{
		if(m_bOriginalFlg)
		{
			ClearAll();
		}
	}
	void ClearAll()
	{
		std::map<BYTE,TS_DESCRIPTOR_BASE*>::iterator it;
		for(it=m_Descriptors.begin();it!=m_Descriptors.end();it++)
		{
			delete it->second;
		}
		m_Descriptors.clear();
	}
	BOOL Append(TS_DESCRIPTOR_BASE *lpDescriptor)
	{
		if(Get(lpDescriptor->byTag)) return FALSE;
		m_Descriptors.insert(std::pair<BYTE,TS_DESCRIPTOR_BASE*>(lpDescriptor->byTag,lpDescriptor));
		return TRUE;
	}
	TS_DESCRIPTOR_BASE* Get(BYTE byTag)
	{
		std::map<BYTE,TS_DESCRIPTOR_BASE*>::iterator it=m_Descriptors.find(byTag);
		if(it==m_Descriptors.end()) return NULL;
		return it->second;
	}
	BOOL Erase(BYTE byTag)
	{
		std::map<BYTE,TS_DESCRIPTOR_BASE*>::iterator it=m_Descriptors.find(byTag);
		if(it==m_Descriptors.end()) return FALSE;
		m_Descriptors.erase(it);
		return TRUE;
	}

protected:
	bool m_bOriginalFlg;
	std::map<BYTE,TS_DESCRIPTOR_BASE*> m_Descriptors;
};